using System.Collections.Generic;
using System.Linq;
using UnityEngine;

namespace Ruvik
{
    class PHUndo
    {
        class BonesState
        {
            public Vector3[] positions = new Vector3[18];
            public Vector3[] rotations = new Vector3[18];
        }
        static List<BonesState> states = new List<BonesState>();
        static public void RestoreState()
        {
            if (states.Count <= 0)
                return;
            int storeIndex = 0;
            BonesState state = states.Last();
            PHUtils.head.transform.position = state.positions[storeIndex];
            PHUtils.head.transform.eulerAngles = state.rotations[storeIndex];
            storeIndex++;
            PHUtils.neck.transform.position = state.positions[storeIndex];
            PHUtils.neck.transform.eulerAngles = state.rotations[storeIndex];
            storeIndex++;
            for (int i = 0; i < 2; i++)
            {
                PHUtils.shoulders[i].transform.position = state.positions[storeIndex];
                PHUtils.shoulders[i].transform.eulerAngles = state.rotations[storeIndex];
                storeIndex++;
                PHUtils.elbows[i].transform.position = state.positions[storeIndex];
                PHUtils.elbows[i].transform.eulerAngles = state.rotations[storeIndex];
                storeIndex++;
                PHUtils.hands[i].transform.position = state.positions[storeIndex];
                PHUtils.hands[i].transform.eulerAngles = state.rotations[storeIndex];
                storeIndex++;
            }
            PHUtils.chest.transform.position = state.positions[storeIndex];
            PHUtils.chest.transform.eulerAngles = state.rotations[storeIndex];
            storeIndex++;
            PHUtils.waist.transform.position = state.positions[storeIndex];
            PHUtils.waist.transform.eulerAngles = state.rotations[storeIndex];
            storeIndex++;
            PHUtils.pelvis.transform.position = state.positions[storeIndex];
            PHUtils.pelvis.transform.eulerAngles = state.rotations[storeIndex];
            storeIndex++;
            PHUtils.hip.transform.position = state.positions[storeIndex];
            PHUtils.hip.transform.eulerAngles = state.rotations[storeIndex];
            storeIndex++;
            for (int i = 0; i < 2; i++)
            {
                PHUtils.thighs[i].transform.position = state.positions[storeIndex];
                PHUtils.thighs[i].transform.eulerAngles = state.rotations[storeIndex];
                storeIndex++;
                PHUtils.knees[i].transform.position = state.positions[storeIndex];
                PHUtils.knees[i].transform.eulerAngles = state.rotations[storeIndex];
                storeIndex++;
                PHUtils.feet[i].transform.position = state.positions[storeIndex];
                PHUtils.feet[i].transform.eulerAngles = state.rotations[storeIndex];
                storeIndex++;
            }
            states.Remove(states.Last());
        }
        static public void StoreState()
        {
            int storeIndex = 0;
            BonesState state = new BonesState();
            state.positions[storeIndex] = PHUtils.head.transform.position;
            state.rotations[storeIndex] = PHUtils.head.transform.eulerAngles;
            storeIndex++;
            state.positions[storeIndex] = PHUtils.neck.transform.position;
            state.rotations[storeIndex] = PHUtils.neck.transform.eulerAngles;
            storeIndex++;
            for (int i = 0; i < 2; i++)
            {
                state.positions[storeIndex] = PHUtils.shoulders[i].transform.position;
                state.rotations[storeIndex] = PHUtils.shoulders[i].transform.eulerAngles;
                storeIndex++;
                state.positions[storeIndex] = PHUtils.elbows[i].transform.position;
                state.rotations[storeIndex] = PHUtils.elbows[i].transform.eulerAngles;
                storeIndex++;
                state.positions[storeIndex] = PHUtils.hands[i].transform.position;
                state.rotations[storeIndex] = PHUtils.hands[i].transform.eulerAngles;
                storeIndex++;
            }
            state.positions[storeIndex] = PHUtils.chest.transform.position;
            state.rotations[storeIndex] = PHUtils.chest.transform.eulerAngles;
            storeIndex++;
            state.positions[storeIndex] = PHUtils.waist.transform.position;
            state.rotations[storeIndex] = PHUtils.waist.transform.eulerAngles;
            storeIndex++;
            state.positions[storeIndex] = PHUtils.pelvis.transform.position;
            state.rotations[storeIndex] = PHUtils.pelvis.transform.eulerAngles;
            storeIndex++;
            state.positions[storeIndex] = PHUtils.hip.transform.position;
            state.rotations[storeIndex] = PHUtils.hip.transform.eulerAngles;
            storeIndex++;
            for (int i = 0; i < 2; i++)
            {
                state.positions[storeIndex] = PHUtils.thighs[i].transform.position;
                state.rotations[storeIndex] = PHUtils.thighs[i].transform.eulerAngles;
                storeIndex++;
                state.positions[storeIndex] = PHUtils.knees[i].transform.position;
                state.rotations[storeIndex] = PHUtils.knees[i].transform.eulerAngles;
                storeIndex++;
                state.positions[storeIndex] = PHUtils.feet[i].transform.position;
                state.rotations[storeIndex] = PHUtils.feet[i].transform.eulerAngles;
                storeIndex++;
            }
            if(states.Count>=100)
		states.Remove(states.First());
            states.Add(state);
        }
    }
}
